SystemOrganization addCategory: #FuelPackaging!

!MCMczWriter methodsFor: '*FuelPackaging' stamp: 'pre 1/16/2013 13:45'!
serializeBinaryModule: aMCVersion 
	| aPackage |
	aPackage := FuelPackage newFromPackageNamed: aMCVersion package name.
	^ aPackage serialize contents! !

!MCMczWriter methodsFor: '*FuelPackaging' stamp: 'JH 1/16/2013 11:49'!
writeBinaryModule: aMCVersion

	self
		addString: (self serializeBinaryModule: aMCVersion)
		at: 'binaryModule.bin'.! !

!MCMczWriter methodsFor: '*FuelPackaging' stamp: 'JH 1/16/2013 12:10'!
writeVersion: t1 
	self writeFormat.
	self writePackage: t1 package.
	self writeVersionInfo: t1 info.
	self writeDefinitions: t1.
	t1 dependencies
		do: [:t2 | self writeVersionDependency: t2].
	self writeBinaryModule: t1! !

!MCVersion class methodsFor: '*FuelPackaging' stamp: 'pre 1/16/2013 14:03'!
package: t1 info: t2 snapshot: t3 dependencies: t4 binary: fuelPackage
	^ self new
		initializeWithPackage: t1
		info: t2
		snapshot: t3
		dependencies: t4
		binary: fuelPackage! !

!MCVersion methodsFor: '*FuelPackaging' stamp: 'pre 1/18/2013 16:42'!
binary

	^ FuelExtensionVariablesManager MCVersionBinary at: self! !

!MCVersion methodsFor: '*FuelPackaging' stamp: 'pre 1/18/2013 16:40'!
binary: anObject

	FuelExtensionVariablesManager MCVersionBinary at: self put: anObject
	! !

!MCVersion methodsFor: '*FuelPackaging' stamp: 'pre 1/16/2013 14:05'!
initializeWithPackage: aPackage info: aVersionInfo snapshot: aSnapshot dependencies: aCollection binary: fuelPackage
	self
		setPackage: aPackage
		info: aVersionInfo
		snapshot: aSnapshot
		dependencies: aCollection.
	self binary: fuelPackage.
	self addToCache! !

!MCVersion methodsFor: '*FuelPackaging' stamp: 'pre 1/17/2013 13:37'!
load
	
	MCVersionLoader loadVersion: self
	! !

!MCPackage methodsFor: '*FuelPackaging' stamp: 'pre 1/17/2013 10:29'!
wipe
	^ self workingCopy wipe! !

!MCMczReader methodsFor: '*FuelPackaging' stamp: 'pre 1/17/2013 14:31'!
loadBinary

	(self zip memberNamed: 'binaryModule.bin') 
		ifNotNil: [:file | ^ FuelPackage newFromStream: (file contentStream) 
										named: self package name  ]
		ifNil: [ ^ nil ].
				! !

Object subclass: #FuelDeliverable
	instanceVariableNames: 'metacelloConfiguration metacelloVersion objects fileStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPackaging'!

!FuelDeliverable commentStamp: 'pre 1/18/2013 14:09' prior: 0!
A FuelDeliverable is a package delivering a full running application. It includes a metacello configuration and serialized runtime objects, e.g. a running game.

Example Usage (executed in the inspector of a SystemWindow):
| a |
a := FuelDeliverable new.
a metacelloConfiguration: ConfigurationOfSmalltalkKoans.
a addObject: self named: 'window'.
a serialize.

This object itself is not serializible with the ordinary FLSerializer because of its reference to a class.
!

!FuelDeliverable class methodsFor: 'as yet unclassified' stamp: 'pre 1/18/2013 14:04'!
metaDataFileName

	^ 'deliverableMetadata'! !

!FuelDeliverable class methodsFor: 'as yet unclassified' stamp: 'pre 1/18/2013 13:58'!
metacelloFileName

	^ 'configuration.mtc'! !

!FuelDeliverable class methodsFor: 'as yet unclassified' stamp: 'pre 1/18/2013 13:54'!
newFromZipFileStream: fileStream

	| p |
	
	p := self new.
	p fileStream: fileStream.
	^ p! !

!FuelDeliverable class methodsFor: 'as yet unclassified' stamp: 'pre 1/18/2013 14:16'!
objectsFileName

	^ 'objects'! !

!FuelDeliverable methodsFor: 'as yet unclassified' stamp: 'pre 1/18/2013 09:47'!
addObject: anObject named: objectName

	self objects at: objectName put: anObject! !

!FuelDeliverable methodsFor: 'as yet unclassified' stamp: 'pre 1/18/2013 14:20'!
configurationNameOfPackage: packageName

	^ 'ConfigurationOf' , packageName! !

!FuelDeliverable methodsFor: 'as yet unclassified' stamp: 'pre 1/18/2013 14:41'!
determineMetaData

	| metaData |
	metaData := Dictionary new.
	metaData 
		add: #metacelloVersion -> self metacelloVersion;
		add: #packageName -> self packageName;
		add: #vmVersion -> Smalltalk vmVersion;
		add: #imageVersion -> Smalltalk version.
	
	^ metaData
	"Things like PackageName, ImageVersion, Kind of Image, VM Version"
	! !

!FuelDeliverable methodsFor: 'accessing' stamp: 'pre 1/18/2013 14:37'!
fileStream

	^ fileStream! !

!FuelDeliverable methodsFor: 'accessing' stamp: 'pre 1/18/2013 14:37'!
fileStream: anObject

	fileStream := anObject! !

!FuelDeliverable methodsFor: 'as yet unclassified' stamp: 'pre 1/18/2013 09:36'!
flushZip: aZipArchive ToFile: fileName

	| stream |
.
	stream := FileStream newFileNamed: fileName.
	aZipArchive writeTo: stream.
	stream close.! !

!FuelDeliverable methodsFor: 'as yet unclassified' stamp: 'pre 1/18/2013 09:47'!
initialize

	self objects: Dictionary new.! !

!FuelDeliverable methodsFor: 'as yet unclassified' stamp: 'pre 1/18/2013 14:42'!
isInstallable: metaData

	^  (metaData at: #imageVersion) = (Smalltalk version)
! !

!FuelDeliverable methodsFor: 'as yet unclassified' stamp: 'pre 1/18/2013 14:48'!
isSerializable

	^ ((self metacelloConfiguration notNil)
		and:
	   [ self metacelloVersion notNil ])
	      and:
	   [ self objects values notEmpty ]! !

!FuelDeliverable methodsFor: 'as yet unclassified' stamp: 'pre 1/18/2013 15:00'!
materialize

	| zip metaData |
	
	zip := ZipArchive new.
	zip readFrom: self fileStream.
	
	metaData := self materializeMetaData: zip.
	(self isInstallable: metaData) ifTrue: [
		| objects |
		self materializeAndLoadMetacelloConfig: zip 
			 forPackage: (metaData at: #packageName)
			 andVersion: (metaData at: #metacelloVersion).
			
		objects := self materializeObjects: zip.
		"Postprocessing? like opening a window?"
		
		^ objects
	] ifFalse: [ "TODO: raise an error" ].

! !

!FuelDeliverable methodsFor: 'as yet unclassified' stamp: 'pre 1/18/2013 14:59'!
materializeAndLoadMetacelloConfig: zip forPackage: packageName andVersion: versionString

	(zip memberNamed: self class metacelloFileName)
		ifNotNil: [ :file | 
				(FuelPackage newFromStream: file contentStream named: packageName) materialize
					ifTrue: [ 
						((Smalltalk at: (self configurationNameOfPackage: packageName) asSymbol) 
							project version: versionString) load. ]
					ifFalse: [ "TODO: Raise an Error" ]
			]
		ifNil: [ "Raise an Error" ].
! !

!FuelDeliverable methodsFor: 'as yet unclassified' stamp: 'pre 1/18/2013 14:58'!
materializeMetaData: zip.
	
	(zip memberNamed: self class metaDataFileName)
		ifNotNil: [:file | ^ FLMaterializer materializeFromByteArray: file contentStream ]
		ifNil: [ "TODO: raise error" ]! !

!FuelDeliverable methodsFor: 'as yet unclassified' stamp: 'pre 1/18/2013 14:58'!
materializeObjects: zip.
		
	(zip memberNamed: self class objectsFileName)
		ifNotNil: [:file | ^ FLMaterializer materializeFromByteArray: file contentStream ]
		ifNil: [ "TODO: raise error" ]! !

!FuelDeliverable methodsFor: 'as yet unclassified' stamp: 'pre 1/18/2013 14:14'!
metaData
	
	| zip |
	
	self fileStream ifNotNil: [ :stream |
		zip := ZipArchive new.
		zip readFrom: self fileStream.
		^ self materializeMetaData: zip ]
	ifNil: [ ^self determineMetaData ]
	! !

!FuelDeliverable methodsFor: 'accessing' stamp: 'pre 1/17/2013 13:26'!
metacelloConfiguration

	^ metacelloConfiguration! !

!FuelDeliverable methodsFor: 'accessing' stamp: 'pre 1/17/2013 13:26'!
metacelloConfiguration: anObject

	metacelloConfiguration := anObject! !

!FuelDeliverable methodsFor: 'accessing' stamp: 'pre 1/18/2013 14:37'!
metacelloVersion

	^ metacelloVersion! !

!FuelDeliverable methodsFor: 'accessing' stamp: 'pre 1/18/2013 14:37'!
metacelloVersion: anObject

	metacelloVersion := anObject! !

!FuelDeliverable methodsFor: 'accessing' stamp: 'pre 1/17/2013 13:26'!
objects

	^ objects! !

!FuelDeliverable methodsFor: 'accessing' stamp: 'pre 1/17/2013 13:26'!
objects: anObject

	objects := anObject! !

!FuelDeliverable methodsFor: 'as yet unclassified' stamp: 'pre 1/18/2013 09:46'!
packageName
	
	| name |
	
	name := self metacelloConfiguration name asString.
	^ name copyFrom: 16 to: name size.! !

!FuelDeliverable methodsFor: 'as yet unclassified' stamp: 'pre 1/18/2013 14:47'!
serialize

	| zip |
	self isSerializable ifFalse: [ "TODO: throw error" ^false].
	
	zip := ZipArchive new.
	
	self 
		serializeMetadataFile: zip;
		serializeMetacelloConfigurationIn: zip;
		serializeObjectsIn: zip.
	
	self flushZip: zip ToFile: self packageName.
	"serialize the Configuration as Package and serialize the objects each as fuel objects. Store everything in a package."
! !

!FuelDeliverable methodsFor: 'as yet unclassified' stamp: 'pre 1/18/2013 14:17'!
serializeMetacelloConfigurationIn: aZipArchive

	| configPackage |
	configPackage := FuelPackage 
						newFromPackageNamed: self metacelloConfiguration package name.
						
	aZipArchive addString: configPackage serialize contents 
				as: (self class metacelloFileName).! !

!FuelDeliverable methodsFor: 'as yet unclassified' stamp: 'pre 1/18/2013 14:19'!
serializeMetadataFile: zipArchive
		
	zipArchive addString: (self serializeObject: self determineMetaData)
				as: (self class metaDataFileName).
	! !

!FuelDeliverable methodsFor: 'as yet unclassified' stamp: 'pre 1/18/2013 09:54'!
serializeObject: object

	| aStream |
	aStream := RWBinaryOrTextStream on: String new.
	aStream binary.
	FLSerializer serialize: object on: aStream.
	^ aStream contents! !

!FuelDeliverable methodsFor: 'as yet unclassified' stamp: 'pre 1/18/2013 14:18'!
serializeObjectsIn: aZipArchive

	aZipArchive addString: (self serializeObject: self objects)
					 as: self class objectsFileName.
	! !

Object subclass: #FuelExtensionVariablesManager
	instanceVariableNames: ''
	classVariableNames: 'MCVersionBinary'
	poolDictionaries: ''
	category: 'FuelPackaging'!

!FuelExtensionVariablesManager class methodsFor: 'as yet unclassified' stamp: 'pre 1/18/2013 16:41'!
MCVersionBinary

	^ MCVersionBinary! !

!FuelExtensionVariablesManager class methodsFor: 'as yet unclassified' stamp: 'pre 1/18/2013 16:38'!
initialize

	super initialize.
	MCVersionBinary := IdentityDictionary new.! !

Object subclass: #FuelPackage
	instanceVariableNames: 'packageName sourceStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPackaging'!

!FuelPackage class methodsFor: 'as yet unclassified' stamp: 'pre 1/16/2013 13:36'!
newFromPackageNamed: packageName

	| p |
	p := self new.
	p packageName: packageName.
	^p! !

!FuelPackage class methodsFor: 'as yet unclassified' stamp: 'rms 1/16/2013 15:10'!
newFromStream: aStream named: packageName

	| p |
	p := self new.
	p sourceStream: aStream;
	   packageName: packageName.
	^p! !

!FuelPackage methodsFor: 'as yet unclassified' stamp: 'pre 1/17/2013 10:37'!
handleLoadedPackages

	(MCPackage named: self packageName) wipe.
	ClassOrganizer cleanUp: true.! !

!FuelPackage methodsFor: 'as yet unclassified' stamp: 'pre 1/21/2013 16:18'!
materialize

	(self packageName = 'FuelPackaging' or: 
	 ('Configuration*' match: self packageName)) ifTrue: [
		^ false
	].

	Transcript show: '' , Character cr , 'Materializing: ' , self packageName , Character cr.
	self handleLoadedPackages.
	self sourceStream binary.
		
	[ FLPackageLoader new loadFrom: self sourceStream copy. ]
		on: Error
		do: [ :er |
			Transcript show: 'Error Materializing: ' , er description, Character cr.
			^false ].
	^ true! !

!FuelPackage methodsFor: 'accessing' stamp: 'pre 1/16/2013 13:36'!
packageName

	^ packageName! !

!FuelPackage methodsFor: 'accessing' stamp: 'pre 1/16/2013 13:36'!
packageName: anObject

	packageName := anObject! !

!FuelPackage methodsFor: 'as yet unclassified' stamp: 'pre 1/16/2013 14:22'!
serialize

	| aStream |
	aStream := RWBinaryOrTextStream on: String new.
	aStream binary.
      FLPackageStore new storePackageNamed: self packageName on: aStream.
	^ aStream
	! !

!FuelPackage methodsFor: 'accessing' stamp: 'rms 1/16/2013 13:59'!
sourceStream

	^ sourceStream! !

!FuelPackage methodsFor: 'accessing' stamp: 'rms 1/16/2013 13:59'!
sourceStream: anObject

	sourceStream := anObject! !

!MCVersionLoader methodsFor: '*FuelPackaging' stamp: 'pre 1/17/2013 13:36'!
load
	| loader |
	self checkForModifications.
	loader := MCPackageLoader new.
	versions do: [:ea |
		(ea binary notNil and: [ea binary materialize]) ifFalse: [
		"fallback"
			loader appendToPreamble: (String streamContents: [:s | ea logLoadingOn: s]).
			ea canOptimizeLoading
				ifTrue: [ea patch applyTo: loader]
				ifFalse: [loader updatePackage: ea package withSnapshot: ea snapshot]]

		].
	loader loadWithNameLike: versions first info name.
	versions do: [:ea | ea workingCopy loaded: ea]! !

!MCWorkingCopy methodsFor: '*FuelPackaging' stamp: 'pre 1/17/2013 10:28'!
wipe

	MCPackageLoader unloadPackage: self package.
	! !

!CompiledMethod methodsFor: '*FuelPackaging' stamp: 'pre 1/14/2013 12:32'!
category

	^self methodClass organization categoryOfElement: self selector! !

!CompiledMethod methodsFor: '*FuelPackaging' stamp: 'pre 1/14/2013 12:39'!
isNamedPrimitive 	
	
	^ self primitive = 117! !

!MCVersionReader methodsFor: '*FuelPackaging' stamp: 'pre 1/16/2013 14:03'!
basicVersion
	^ MCVersion
		package: self package
		info: self info
		snapshot: self snapshot
		dependencies: self dependencies
		binary: self binary! !

!MCVersionReader methodsFor: '*FuelPackaging' stamp: 'pre 1/16/2013 14:25'!
binary
	
	^ self loadBinary! !

!MCVersionReader methodsFor: '*FuelPackaging' stamp: 'pre 1/16/2013 14:11'!
loadBinary
	self subclassResponsibility! !

!Class methodsFor: '*FuelPackaging' stamp: 'pre 1/14/2013 12:35'!
basicCategory

	^category! !

!Class methodsFor: '*FuelPackaging' stamp: 'pre 1/14/2013 12:36'!
basicCategory: aString

	category := aString! !
FuelExtensionVariablesManager initialize!
